ghc-7.10.2: The GHC API

Safe Haskell | None
Language | Haskell2010

TcTyDecls

# Documentation

calcRecFlags :: ModDetails -> Bool -> RoleAnnots -> [TyThing] -> RecTyInfo Source

data RecTyInfo Source

Constructors

RTI |
Fields rti_promotable :: Bool rti_roles :: Name -> [Role] rti_is_rec :: Name -> RecFlag

calcSynCycles :: [LTyClDecl Name] -> [SCC (LTyClDecl Name)] Source

calcClassCycles :: Class -> [[TyCon]] Source

type RoleAnnots = NameEnv (LRoleAnnotDecl Name) Source

extractRoleAnnots :: TyClGroup Name -> RoleAnnots Source

emptyRoleAnnots :: RoleAnnots Source

lookupRoleAnnots :: RoleAnnots -> Name -> Maybe (LRoleAnnotDecl Name) Source